package cn.bunny.controller;

import cn.bunny.feign.CloudFeignClient;
import cn.bunny.properties.OrderProperties;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/api")
@Tag(name = "获取配置属性名称", description = "获取配置属性名称")
public class PropertiesController {

    @Autowired
    private OrderProperties orderProperties;

    @Qualifier("cn.bunny.feign.CloudFeignClient")
    @Autowired
    private CloudFeignClient cloudFeignClient;

    @GetMapping("config")
    @Operation(summary = "获取云端配置属性", description = "获取云端配置属性")
    public String getConfig() {
        return "timeout：" + orderProperties.getTimeout() + "；autoConfirm：" + orderProperties.getConfirm() + "；dbUrl：" + orderProperties.getDbUrl();
    }

    @Operation(summary = "远程调用拦截token", description = "远程调用拦截token")
    @GetMapping("product")
    String getProduct(@RequestParam("id") Long id) {
        // TokenRequestInterceptor 会将内容放到请求头中之后在另一个微服务中查看请求头即可
        return cloudFeignClient.getProduct(id);
    }
}
